<?php
/**
 * Clase Base FN para BaseArArqueoCabeceraFN
 *
 * @package    
 * @subpackage BaseArArqueoCabeceraFN
 * @author     Willy
 * @version    SVN:: BaseArArqueoCabeceraFN.class.php,v 1.1 2020-06-30 13:51:23 william.taype Exp $
 */
class BaseArArqueoCabeceraFN extends ArArqueoCabeceraBN
{
  private static $fieldNames = array (
    'Idclase'=>'idclase', 'Idsucursal'=>'idsucursal', 'Idmercado'=>'idmercado', 'Idcolaborador'=>'idcolaborador', 'Fecha'=>'fecha', 'Descripcionsucursal'=>'descripcionsucursal', 'Descripcionmercado'=>'descripcionmercado', 'Descripcioncolaborador'=>'descripcioncolaborador', 'Estado'=>'estado', 'Fechacierre'=>'fechacierre', 'Total'=>'total', 'Fecharegistro'=>'fecharegistro', 'Usuarioregistro'=>'usuarioregistro', 'Fechamodificacion'=>'fechamodificacion', 'Usuariomodificacion'=>'usuariomodificacion'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, descripcionsucursal, descripcionmercado, descripcioncolaborador, estado, fechacierre, total, fecharegistro, usuarioregistro, fechamodificacion, usuariomodificacion,idgastoreferencia FROM ar_arqueo_cabecera WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
      //echo $sql;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, descripcionsucursal, descripcionmercado, descripcioncolaborador, estado, fechacierre, total, fecharegistro, usuarioregistro, fechamodificacion, usuariomodificacion,idgastoreferencia FROM ar_arqueo_cabecera WHERE 1 ".$where;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdclase()){ $where .= " AND idclase = '".$this->getIdclase()."'"; }
      if($this->getIdsucursal()){ $where .= " AND idsucursal = '".$this->getIdsucursal()."'"; }
      if($this->getIdmercado()){ $where .= " AND idmercado = '".$this->getIdmercado()."'"; }
      if($this->getIdcolaborador()){ $where .= " AND idcolaborador = '".$this->getIdcolaborador()."'"; }
      if($this->getFecha()){ $where .= " AND fecha = '".$this->getFecha()."'"; }
      if($this->getFechainicio()){ $where .= " AND fecha >= '".$this->getFechainicio()."'"; }
      if($this->getFechafinal()){ $where .= " AND fecha <= '".$this->getFechafinal()."'"; }
      if($this->getDescripcionsucursal()){ $where .= " AND descripcionsucursal = '".$this->getDescripcionsucursal()."'"; }
      if($this->getDescripcionmercado()){ $where .= " AND descripcionmercado = '".$this->getDescripcionmercado()."'"; }
      if($this->getDescripcioncolaborador()){ $where .= " AND descripcioncolaborador = '".$this->getDescripcioncolaborador()."'"; }
      if($this->getEstado()){ $where .= " AND estado = '".$this->getEstado()."'"; }
      if($this->getFechacierre()){ $where .= " AND fechacierre = '".$this->getFechacierre()."'"; }
      if($this->getTotal()){ $where .= " AND total = '".$this->getTotal()."'"; }
      if($this->getFecharegistro()){ $where .= " AND fecharegistro = '".$this->getFecharegistro()."'"; }
      if($this->getUsuarioregistro()){ $where .= " AND usuarioregistro = '".$this->getUsuarioregistro()."'"; }
      if($this->getFechamodificacion()){ $where .= " AND fechamodificacion = '".$this->getFechamodificacion()."'"; }
      if($this->getUsuariomodificacion()){ $where .= " AND usuariomodificacion = '".$this->getUsuariomodificacion()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, descripcionsucursal, descripcionmercado, descripcioncolaborador, estado, fechacierre, total, fecharegistro, usuarioregistro, fechamodificacion, usuariomodificacion,idgastoreferencia FROM ar_arqueo_cabecera WHERE 1 AND idclase='".$this->getIdclase()."' AND idsucursal='".$this->getIdsucursal()."' AND idmercado='".$this->getIdmercado()."' AND idcolaborador='".$this->getIdcolaborador()."' AND fecha='".$this->getFecha()."'; ";
      //echo $sql;
       $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseArArqueoCabeceraFN = new BaseArArqueoCabeceraFN();
    $o_BaseArArqueoCabeceraFN->setIdclase($o_propel->idclase);
    $o_BaseArArqueoCabeceraFN->setIdsucursal($o_propel->idsucursal);
    $o_BaseArArqueoCabeceraFN->setIdmercado($o_propel->idmercado);
    $o_BaseArArqueoCabeceraFN->setIdcolaborador($o_propel->idcolaborador);
    $o_BaseArArqueoCabeceraFN->setFecha($o_propel->fecha);
    $o_BaseArArqueoCabeceraFN->setDescripcionsucursal($o_propel->descripcionsucursal);
    $o_BaseArArqueoCabeceraFN->setDescripcionmercado($o_propel->descripcionmercado);
    $o_BaseArArqueoCabeceraFN->setDescripcioncolaborador($o_propel->descripcioncolaborador);
    $o_BaseArArqueoCabeceraFN->setEstado($o_propel->estado);
    $o_BaseArArqueoCabeceraFN->setFechacierre($o_propel->fechacierre);
    $o_BaseArArqueoCabeceraFN->setTotal($o_propel->total);
    $o_BaseArArqueoCabeceraFN->setFecharegistro($o_propel->fecharegistro);
    $o_BaseArArqueoCabeceraFN->setUsuarioregistro($o_propel->usuarioregistro);
    $o_BaseArArqueoCabeceraFN->setFechamodificacion($o_propel->fechamodificacion);
    $o_BaseArArqueoCabeceraFN->setUsuariomodificacion($o_propel->usuariomodificacion);
    $o_BaseArArqueoCabeceraFN->setIdgastoreferencia($o_propel->idgastoreferencia);
    return $o_BaseArArqueoCabeceraFN;
  }
}